function Create(self)

	self.mapwrapx = SceneMan.SceneWrapsX;
	self.checktimer = Timer();
	self.tracklist = {};
	self.parlist = {};
	self.tracknumber = 0;
	self.lastcursorpos = Vector(0,0);
	self.actionmode = 0;
	self.canjump = false;
	self.runpos = Vector(0,19);

	self.trackpiecelength = 27;
	self.cartspeed = 10;

end

function Update(self)

	self.ToDelete = false;
	self.ToSettle = false;
	self.RotAngle = 0;

	if self.actionmode == 0 then
		self.PinStrength = 1000;

		if self.checktimer:IsPastSimMS(200) == true then
			for actor in MovableMan.Actors do
				if SceneMan:ShortestDistance(self.Pos,actor.Pos,self.mapwrapx).Magnitude < self.Radius and actor:GetController():IsState(Controller.BODY_JUMP) == true then
					self.cargo = actor;
					self.actionmode = 1;
					break;
				end
			end
		end
	elseif self.actionmode == 1 then
		if MovableMan:IsActor(self.cargo) == true then
			self.cargo.Pos = self.Pos;
			self.cargo.Vel = self.Vel;
			if self.cargo:GetController():IsState(Controller.BODY_JUMP) == true and self.canjump == true then
				self.actionmode = 0;
				self.cargo = nil;
			elseif self.cargo:GetController():IsState(Controller.BODY_JUMP) == false then
				self.canjump = true;
			end

			if self.cargo:GetController():IsState(Controller.BODY_CROUCH) == true and self.cargo:IsPlayerControlled() == true then
				self.lastcursorpos = self.Pos + self.runpos;
				self.cursor = CreateActor("Mine Cart Cursor");
				self.lastcursorpos = self.Pos + self.runpos;
				self.cursor.Pos = self.lastcursorpos;
				self.cursor.Team = self.cargo.Team;
				MovableMan:AddActor(self.cursor);
				ActivityMan:GetActivity():SwitchToActor(self.cursor,self.cargo:GetController().Player,self.cargo.Team);
				self.actionmode = 2;
			end

		else
			self.cargo = nil;
			self.actionmode = 0;
		end

		if self.tracknumber ~= #self.tracklist then
			self.PinStrength = 0;
			self.drivevel = SceneMan:ShortestDistance(self.Pos + self.runpos,self.tracklist[self.tracknumber],self.mapwrapx);
			self.Vel = Vector(self.drivevel.X,self.drivevel.Y):SetMagnitude(self.cartspeed);
			if self.drivevel.Magnitude < 5 then
				self.tracknumber = self.tracknumber + 1;
			end
		else
			self.PinStrength = 1000;
		end

	elseif self.actionmode == 2 then
		self.PinStrength = 1000;

		if MovableMan:IsActor(self.cursor) == true and self.cursor:IsPlayerControlled() == true then
			self.distcheck = SceneMan:ShortestDistance(self.cursor.Pos,Vector(self.lastcursorpos.X,self.lastcursorpos.Y),self.mapwrapx);
			if self.distcheck.Magnitude > self.trackpiecelength then
				self.listnum = #self.tracklist+1;
				self.tracklist[self.listnum] = self.lastcursorpos + Vector(self.distcheck.X,self.distcheck.Y):SetMagnitude(self.trackpiecelength);

				self.particle = CreateMOSRotating("Mine Cart Track");
				self.particle.Pos = self.cursor.Pos;
				self.particle.RotAngle = SceneMan:ShortestDistance(self.Pos + self.runpos,self.tracklist[self.listnum],self.mapwrapx).Magnitude;
				MovableMan:AddParticle(self.particle);

				self.parlist[self.listnum] = self.particle;

				self.lastcursorpos = Vector(self.tracklist[self.listnum].X,self.tracklist[self.listnum].Y);
			end
			if self.cursor:GetController():IsState(Controller.BODY_CROUCH) == true then
				ActivityMan:GetActivity():SwitchToActor(self.cargo,self.cursor:GetController().Player,self.cargo.Team);
				self.cursor.ToDelete = true;
				self.actionmode = 1;
			end
		else
			self.actiomode = 1;
		end

	end

end