function Create(self)

	self.mapwrapx = SceneMan.SceneWrapsX;
	self.checktimer = Timer();
	self.tracklist = {};
	self.parlist = {};
	self.tracknumber = 1;
	self.lastcursorpos = Vector(0,0);
	self.actionmode = 0;
	self.canjump = false;
	self.runpos = Vector(0,19);

	self.trackpiecelength = 27;
	self.cartspeed = 7;
	self.trackchangedist = 5;

end

function Update(self)

	self.ToDelete = false;
	self.ToSettle = false;
	self:NotResting();
	self.RotAngle = 0;

	if MovableMan:IsActor(self.cargo) == true then
			self.cargo.Pos = self.Pos;
			self.cargo.Vel = self.Vel;
	else
		if self.actionmode ~= 0 then
			self.actionmode = 0;
		end
	end

	if self.actionmode == 0 then

		self.PinStrength = 1000;

		if self.checktimer:IsPastSimMS(500) == true then
			for actor in MovableMan.Actors do
				if SceneMan:ShortestDistance(self.Pos,actor.Pos,self.mapwrapx).Magnitude < self.Radius and actor:GetController():IsState(Controller.BODY_JUMP) == true then
					self.cargo = actor;
					self.actionmode = 1;
					break;
				end
			end
		end

	elseif self.actionmode == 1 then

		if MovableMan:IsActor(self.cargo) == true then

			if self.cargo:IsPlayerControlled() == true then

				if self.cargo:GetController():IsState(Controller.BODY_CROUCH) == true then
					self.lastcursorpos = self.Pos + self.runpos;
					self.cursor = CreateActor("Mine Cart Cursor");
					self.lastcursorpos = self.Pos + self.runpos;
					self.cursor.Pos = self.lastcursorpos;
					self.cursor.Team = self.cargo.Team;
					MovableMan:AddActor(self.cursor);
					ActivityMan:GetActivity():SwitchToActor(self.cursor,self.cargo:GetController().Player,self.cargo.Team);
					self.tracklist = {};
					for i = 1, #self.parlist do
						if MovableMan:IsParticle(self.parlist[i]) == true then
							self.parlist[i].ToDelete = true;
						end
					end
					self.parlist = {};
					self.tracklist[#self.tracklist+1] = self.lastcursorpos;
					self.tracknumber = 1;
					self.actionmode = 2;
				end

				if self.cargo:GetController():IsState(Controller.HOLD_RIGHT) == true then
					if self.tracknumber <= #self.tracklist then
						self.PinStrength = 0;
						self.drivevel = SceneMan:ShortestDistance(self.Pos + self.runpos,self.tracklist[self.tracknumber],self.mapwrapx);
						self.Vel = Vector(self.drivevel.X,self.drivevel.Y):SetMagnitude(self.cartspeed);
						if self.drivevel.Magnitude <= self.trackchangedist then
							if self.tracknumber < #self.tracklist then
								self.tracknumber = self.tracknumber + 1;
							else
								self.PinStrength = 1000;
								self.Vel = Vector(0,0);
							end
						end
					else
						self.PinStrength = 1000;
						self.Vel = Vector(0,0);
					end
				elseif self.cargo:GetController():IsState(Controller.HOLD_LEFT) == true then
					if self.tracknumber >= 1 then
						self.PinStrength = 0;
						self.drivevel = SceneMan:ShortestDistance(self.Pos + self.runpos,self.tracklist[self.tracknumber],self.mapwrapx);
						self.Vel = Vector(self.drivevel.X,self.drivevel.Y):SetMagnitude(self.cartspeed);
						if self.drivevel.Magnitude <= self.trackchangedist then
							if self.tracknumber > 1 then
								self.tracknumber = self.tracknumber - 1;
							else
								self.PinStrength = 1000;
								self.Vel = Vector(0,0);
							end
						end
					else
						self.PinStrength = 1000;
						self.Vel = Vector(0,0);
					end
				else
					self.PinStrength = 1000;
					self.Vel = Vector(0,0);
				end

				if self.cargo:GetController():IsState(Controller.BODY_JUMP) == true and self.canjump == true then
					self.actionmode = 0;
					self.cargo = nil;
					self.canjump = false;
					self.checktimer:Reset();
				elseif self.cargo:GetController():IsState(Controller.BODY_JUMP) == false then
					self.canjump = true;
				end

			end

		else
			self.cargo = nil;
			self.actionmode = 0;
		end

		for i = 1, #self.parlist do
			if MovableMan:IsParticle(self.parlist[i]) == true then
				self.parlist[i].ToDelete = false;
				self.parlist[i].ToSettle = false;
				self.parlist[i].PinStrength = 1000;
			end
		end

	elseif self.actionmode == 2 then
		self.PinStrength = 1000;

		if MovableMan:IsActor(self.cursor) == true then
			if self.cursor:IsPlayerControlled() == true then

				if self.cursor:GetController():IsState(Controller.BODY_CROUCH) == true then
					ActivityMan:GetActivity():SwitchToActor(self.cargo,self.cursor:GetController().Player,self.cargo.Team);
					self.cursor.ToDelete = true;
					self.actionmode = 1;
				end

				self.distcheck = SceneMan:ShortestDistance(self.cursor.Pos,Vector(self.lastcursorpos.X,self.lastcursorpos.Y),self.mapwrapx);
				if self.distcheck.Magnitude > self.trackpiecelength then
					self.lastcursorpos = self.lastcursorpos + (SceneMan:ShortestDistance(self.lastcursorpos,self.cursor.Pos,self.mapwrapx):SetMagnitude(self.trackpiecelength));
					self.tracklist[#self.tracklist+1] = self.lastcursorpos;

					self.particle = CreateMOSRotating("Mine Cart Track");
					self.particle.Pos = self.tracklist[#self.tracklist];
					self.particle.RotAngle = SceneMan:ShortestDistance(self.tracklist[#self.tracklist],self.cursor.Pos,self.mapwrapx).AbsRadAngle;
					MovableMan:AddParticle(self.particle);

					self.parlist[#self.parlist+1] = self.particle;

				end
			else
				self.cursor.ToDelete = true;
				self.actionmode = 1;
			end
		else
			self.actiomode = 1;
		end

	end

end